'''
clamav module, version 0.5

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import socket,re,string,tempfile

def f_clamscan(stream,scanner):
    pf=popen(scanner+['-'])
    pf.write(fromhdr())
    pf.write(stream)
    pf.close(1)
    pf.wait()
    ret=[]
    for line in pf.readlines():
      if re.search(" FOUND",line):
        ret.append(line)
    pf.close(2)
    if ret==[]:
      vir=''
    else:
      l=re.search(": (.*) FOUND",string.rstrip(ret[0]))
      if l:
        vir=l.group(1)
      else:
        debug(0,'CLAMSCAN: ',ret)
        raise ascanner,'clamscan: '+ret
    return vir,ret

def f_clamscandir(fda,scanner):
    ret=[]
    for fdir in fda:
      pf=popen(scanner+[fdir])
      pf.wait()
      for line in pf.readlines():
        if re.search(" FOUND",line):
          ret.append(line)
      pf.close()
    if ret==[]:
      vir=''
    else:
      l=re.search(": (.*) FOUND",string.rstrip(ret[0]))
      if l:
        vir=l.group(1)
      else:
        debug(0,'CLAMSCANF: ',ret)
        raise ascanner,'clamscandir: '+ret
    return vir,ret

def f_clamscanf(data,scanner):
    MBOXFILE=smktemp('.sav.mbox')
    creatembox(MBOXFILE,data,1)
    try:
      vir,ret=clamscandir([MBOXFILE],scanner)
    except:
      tempcleanup(MBOXFILE,'ClamScan')
      raise
    tempcleanup(MBOXFILE,'ClamScan')
    return vir,ret

def f_clamd(stream,scanner):
    if type(scanner)==type('string'): # local socket
      s=socket.socket(socket.AF_UNIX,socket.SOCK_STREAM)
      s.connect(scanner)
    else:
      s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      s.connect((scanner[0],scanner[1]))
    f=s.makefile('rw',BUFSIZE)
    s.send("STREAM\n")
    rl=f.readline()
    l=re.search('^PORT ([0-9]*)',rl)
    if l:
      # Send stream
      ss=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      if type(scanner)==type('string'): # local socket
        ss.connect(('127.0.0.1',string.atoi(l.group(1))))
      else:
        ss.connect((scanner[0],string.atoi(l.group(1))))
      ss.send(fromhdr())
      ss.send(stream)
      ss.shutdown(2)
      ss.close()
      # Read reply
      ret=[]
      for line in f.readlines():
        if not re.search(": OK$",string.rstrip(line)):
          ret.append(line)
      s.shutdown(2)
      s.close()
      if ret==[]:
        vir=''
      else:
        l=re.search(": (.*) FOUND$",string.rstrip(ret[0]))
        if l:
          vir=l.group(1)
        else:
          debug(0,'CLAMD: ',ret)
          raise ascanner,'clamd: '+ret
      return vir,ret
    else:
      raise ascanner,'Protocol error, status: '+rl

class clamscan(ascanner):
  name='clamscan()'
  def __init__(self,arg):
      self.arg=arg
  def scanstream(self,stream):
      detected,virlist=f_clamscanf(stream,self.arg)
      return detected,virlist
  def scanfile(self,files,dirname=''):
      return f_clamscandir([dirname],self.arg)

class clamd(ascanner):
  name='clamd'
  def __init__(self,arg):
      self.arg=arg
  def scanstream(self,stream):
      detected,virlist=f_clamd(stream,self.arg)
      return detected,virlist
